import {Observable as $42h8L$Observable} from "iterable-observer";
import {sleep as $42h8L$sleep, stringifyDOM as $42h8L$stringifyDOM, formToJSON as $42h8L$formToJSON} from "web-utility";

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $eef213ff4197108b$exports = {};

$parcel$export($eef213ff4197108b$exports, "Stack", function () { return $eef213ff4197108b$export$694e0d28c7ffc90c; });
const { push: $eef213ff4197108b$var$push  } = Array.prototype;
class $eef213ff4197108b$export$694e0d28c7ffc90c {
    length = 0;
    use(...middlewares) {
        $eef213ff4197108b$var$push.apply(this, middlewares);
        return this;
    }
    execute(context, depth = 0) {
        const middleware = this[depth];
        if (middleware instanceof Function) return middleware(context, this.execute.bind(this, context, ++depth));
    }
    mount(condition, stack) {
        return this.use((context, next)=>condition(context) ? stack.execute(context) : next());
    }
}


var $0fe1f1400993ba8a$exports = {};

$parcel$export($0fe1f1400993ba8a$exports, "BodyRequestMethods", function () { return $0fe1f1400993ba8a$export$4125cfe7e08e2040; });
$parcel$export($0fe1f1400993ba8a$exports, "HTTPError", function () { return $0fe1f1400993ba8a$export$aa9d629c530f62a7; });
$parcel$export($0fe1f1400993ba8a$exports, "headerParser", function () { return $0fe1f1400993ba8a$export$b725a69477e4d33f; });
$parcel$export($0fe1f1400993ba8a$exports, "parseHeaders", function () { return $0fe1f1400993ba8a$export$eea2c1c5e1a37e50; });
$parcel$export($0fe1f1400993ba8a$exports, "requestXHR", function () { return $0fe1f1400993ba8a$export$4f2a8c8c11a6373a; });
$parcel$export($0fe1f1400993ba8a$exports, "requestFetch", function () { return $0fe1f1400993ba8a$export$bda27a3e49197b9; });
$parcel$export($0fe1f1400993ba8a$exports, "request", function () { return $0fe1f1400993ba8a$export$b5fe3f66a567bec0; });


var $22de11b45b0eeb97$exports = {};

$parcel$export($22de11b45b0eeb97$exports, "parseDocument", function () { return $22de11b45b0eeb97$export$b6a9369736b19f4d; });
$parcel$export($22de11b45b0eeb97$exports, "makeFormData", function () { return $22de11b45b0eeb97$export$2c28ab2e118e73f1; });
$parcel$export($22de11b45b0eeb97$exports, "serializeNode", function () { return $22de11b45b0eeb97$export$a0beee2e55fb5dd1; });
$parcel$export($22de11b45b0eeb97$exports, "serialize", function () { return $22de11b45b0eeb97$export$dfdc1655ccc5b9cb; });
$parcel$export($22de11b45b0eeb97$exports, "readAs", function () { return $22de11b45b0eeb97$export$e209cbb66c5b18c; });


async function $22de11b45b0eeb97$export$b6a9369736b19f4d(response) {
    const text = await response.text(), [type] = response.headers.get("Content-Type")?.split(";") || [];
    return new DOMParser().parseFromString(text, type || "text/html");
}
function $22de11b45b0eeb97$export$2c28ab2e118e73f1(data) {
    const formData = new FormData();
    for (const [key, value] of Object.entries(data))formData.append(key, value);
    return formData;
}
function $22de11b45b0eeb97$export$a0beee2e55fb5dd1(root) {
    var contentType;
    if (!(root instanceof HTMLFormElement)) return {
        contentType: root instanceof SVGElement ? "image/svg" : root instanceof HTMLDocument || root instanceof HTMLElement ? "text/html" : "application/xml",
        data: (0, $42h8L$stringifyDOM)(root)
    };
    if (root.querySelector('input[type="file"][name]')) return {
        contentType: "multipart/form-data",
        data: new FormData(root)
    };
    const data = (0, $42h8L$formToJSON)(root);
    switch(contentType = root.enctype){
        case "text/plain":
            return {
                contentType: contentType,
                data: Object.entries(data).map(([name, value])=>`${name}=${value}`).join("\n")
            };
        case "application/x-www-form-urlencoded":
            return {
                contentType: contentType,
                data: new URLSearchParams(data) + ""
            };
        default:
            return {
                contentType: "application/json",
                data: JSON.stringify(data)
            };
    }
}
function $22de11b45b0eeb97$export$dfdc1655ccc5b9cb(data, contentType) {
    const [type] = contentType?.split(";") || [];
    switch(type){
        case "application/x-www-form-urlencoded":
            return {
                contentType: contentType,
                data: new URLSearchParams(data) + ""
            };
        case "multipart/form-data":
            return {
                data: $22de11b45b0eeb97$export$2c28ab2e118e73f1(data)
            };
        case "application/json":
            return {
                contentType: contentType,
                data: JSON.stringify(data)
            };
        case "text/html":
        case "application/xml":
        case "image/svg":
            return {
                contentType: contentType,
                data: (0, $42h8L$stringifyDOM)(data)
            };
    }
    if (type) return {
        data: data,
        contentType: contentType
    };
    try {
        return {
            contentType: "application/json",
            data: JSON.stringify(data)
        };
    } catch  {
        try {
            return $22de11b45b0eeb97$export$a0beee2e55fb5dd1(data);
        } catch  {
            throw new Error("Unserialized Object needs a specific Content-Type");
        }
    }
}
let $22de11b45b0eeb97$var$FileMethod;
(function(FileMethod) {
    FileMethod["text"] = "readAsText";
    FileMethod["dataURL"] = "readAsDataURL";
    FileMethod["binaryString"] = "readAsBinaryString";
    FileMethod["arrayBuffer"] = "readAsArrayBuffer";
})($22de11b45b0eeb97$var$FileMethod || ($22de11b45b0eeb97$var$FileMethod = {}));
function $22de11b45b0eeb97$export$e209cbb66c5b18c(file, method, encoding) {
    const reader = new FileReader();
    return {
        progress: (0, $42h8L$Observable).fromEvent(reader, "progress"),
        result: new Promise((resolve, reject)=>{
            reader.onerror = reject;
            reader.onload = ()=>resolve(reader.result);
            reader[$22de11b45b0eeb97$var$FileMethod[method]](file, encoding);
        })
    };
}


let $0fe1f1400993ba8a$export$4125cfe7e08e2040;
(function(BodyRequestMethods) {
    BodyRequestMethods["POST"] = "POST";
    BodyRequestMethods["PUT"] = "PUT";
    BodyRequestMethods["PATCH"] = "PATCH";
    BodyRequestMethods["DELETE"] = "DELETE";
})($0fe1f1400993ba8a$export$4125cfe7e08e2040 || ($0fe1f1400993ba8a$export$4125cfe7e08e2040 = {}));
class $0fe1f1400993ba8a$export$aa9d629c530f62a7 extends URIError {
    constructor(message, response){
        super(message);
        Object.assign(this, response);
    }
}
const $0fe1f1400993ba8a$export$b725a69477e4d33f = {
    Link (value) {
        return Object.fromEntries(Array.from(value.matchAll(/<(\S+?)>; rel="(\w+)"(?:; title="(.*?)")?/g), ([_, URI, rel, title])=>[
                rel,
                {
                    rel: rel,
                    URI: URI,
                    title: title
                }
            ]));
    }
};
function $0fe1f1400993ba8a$export$eea2c1c5e1a37e50(raw) {
    return Object.fromEntries(Array.from(raw.trim().matchAll(/^([\w-]+):\s*(.*)/gm), ([_, key, value])=>{
        key = key.replace(/(^[a-z]|-[a-z])/g, (char)=>char.toUpperCase());
        return [
            key,
            $0fe1f1400993ba8a$export$b725a69477e4d33f[key]?.(value) ?? value
        ];
    }));
}
function $0fe1f1400993ba8a$export$4f2a8c8c11a6373a({ method: method = "GET" , path: path , headers: headers = {} , body: body , ...rest }) {
    const request = new XMLHttpRequest(), header_list = headers instanceof Array ? headers : headers?.[Symbol.iterator] instanceof Function ? [
        ...headers
    ] : Object.entries(headers);
    return {
        response: new Promise((resolve, reject)=>{
            request.onload = ()=>resolve({
                    status: request.status,
                    statusText: request.statusText,
                    headers: $0fe1f1400993ba8a$export$eea2c1c5e1a37e50(request.getAllResponseHeaders()),
                    body: request.response
                });
            request.onerror = request.ontimeout = reject;
            request.open(method, path + "");
            for (const [key, value] of header_list)request.setRequestHeader(key, value);
            Object.assign(request, rest);
            request.send(body);
        }),
        upload: (0, $42h8L$Observable).fromEvent(request.upload, "progress"),
        download: (0, $42h8L$Observable).fromEvent(request, "progress")
    };
}
async function $0fe1f1400993ba8a$export$bda27a3e49197b9({ path: path , method: method , headers: headers , withCredentials: withCredentials , body: body , timeout: timeout , responseType: responseType  }) {
    const controller = timeout ? new AbortController() : undefined;
    const timer = timeout && (0, $42h8L$sleep)(timeout / 1000).then(()=>{
        controller.abort();
        throw new RangeError("Timed out");
    });
    const fetchResult = fetch(path + "", {
        method: method,
        headers: headers,
        credentials: withCredentials ? "include" : "omit",
        body: body,
        signal: controller?.signal
    });
    const response = await (timer ? Promise.race([
        timer,
        fetchResult
    ]) : fetchResult);
    const header = $0fe1f1400993ba8a$export$eea2c1c5e1a37e50([
        ...response.headers
    ].map(([key, value])=>`${key}: ${value}`).join("\n"));
    if (response.status !== 204) try {
        var data = await (responseType === "text" ? response.text() : responseType === "document" ? (0, $22de11b45b0eeb97$export$b6a9369736b19f4d)(response) : responseType === "json" ? response.json() : responseType === "arraybuffer" ? response.arrayBuffer() : response.blob());
    } catch  {
        var data = await response.arrayBuffer();
    }
    return {
        status: response.status,
        statusText: response.statusText,
        headers: header,
        body: data
    };
}
function $0fe1f1400993ba8a$export$b5fe3f66a567bec0(options) {
    return typeof globalThis.XMLHttpRequest === "function" ? $0fe1f1400993ba8a$export$4f2a8c8c11a6373a(options) : {
        response: $0fe1f1400993ba8a$export$bda27a3e49197b9(options)
    };
}


var $cbd22d3323bef9ca$exports = {};

$parcel$export($cbd22d3323bef9ca$exports, "HTTPClient", function () { return $cbd22d3323bef9ca$export$45cf759b359d3d24; });



const { splice: $cbd22d3323bef9ca$var$splice  } = Array.prototype;
class $cbd22d3323bef9ca$export$45cf759b359d3d24 extends (0, $eef213ff4197108b$export$694e0d28c7ffc90c) {
    constructor({ baseURI: baseURI = globalThis.document?.baseURI , ...options } = {}){
        super();
        this.baseURI = baseURI, this.options = options;
        super.use(this.defaultWare);
        super.use(async ({ request: data , response: response  })=>{
            data.path = new URL(data.path + "", this.baseURI) + "";
            Object.assign(response, await (0, $0fe1f1400993ba8a$export$b5fe3f66a567bec0)({
                ...options,
                ...data
            }).response);
        });
    }
    defaultWare = async ({ request: request , response: response  }, next)=>{
        const { method: method = "GET" , headers: headers = {} , body: body  } = request;
        if (method in (0, $0fe1f1400993ba8a$export$4125cfe7e08e2040) && body && typeof body === "object") {
            const { contentType: contentType , data: data  } = (0, $22de11b45b0eeb97$export$dfdc1655ccc5b9cb)(body, headers["Content-Type"]);
            if (contentType) headers["Content-Type"] = contentType;
            request.body = data;
        }
        await next();
        if (response.status > 299) throw new (0, $0fe1f1400993ba8a$export$aa9d629c530f62a7)(response.statusText, response);
    };
    use(...middlewares) {
        $cbd22d3323bef9ca$var$splice.call(this, -2, 0, ...middlewares);
        return this;
    }
    async request(data) {
        const context = {
            request: {
                ...data,
                headers: {
                    ...data.headers
                }
            },
            response: {}
        };
        await this.execute(context);
        return context.response;
    }
    async head(path, headers) {
        const { headers: data  } = await this.request({
            method: "HEAD",
            path: path,
            headers: headers
        });
        return data;
    }
    get(path, headers) {
        return this.request({
            method: "GET",
            path: path,
            headers: headers
        });
    }
    post(path, body, headers) {
        return this.request({
            method: "POST",
            path: path,
            headers: headers,
            body: body
        });
    }
    put(path, body, headers) {
        return this.request({
            method: "PUT",
            path: path,
            headers: headers,
            body: body
        });
    }
    patch(path, body, headers) {
        return this.request({
            method: "PATCH",
            path: path,
            headers: headers,
            body: body
        });
    }
    delete(path, body, headers) {
        return this.request({
            method: "DELETE",
            path: path,
            headers: headers,
            body: body
        });
    }
}





export {$eef213ff4197108b$export$694e0d28c7ffc90c as Stack, $0fe1f1400993ba8a$export$4125cfe7e08e2040 as BodyRequestMethods, $0fe1f1400993ba8a$export$aa9d629c530f62a7 as HTTPError, $0fe1f1400993ba8a$export$b725a69477e4d33f as headerParser, $0fe1f1400993ba8a$export$eea2c1c5e1a37e50 as parseHeaders, $0fe1f1400993ba8a$export$4f2a8c8c11a6373a as requestXHR, $0fe1f1400993ba8a$export$bda27a3e49197b9 as requestFetch, $0fe1f1400993ba8a$export$b5fe3f66a567bec0 as request, $cbd22d3323bef9ca$export$45cf759b359d3d24 as HTTPClient, $22de11b45b0eeb97$export$b6a9369736b19f4d as parseDocument, $22de11b45b0eeb97$export$2c28ab2e118e73f1 as makeFormData, $22de11b45b0eeb97$export$a0beee2e55fb5dd1 as serializeNode, $22de11b45b0eeb97$export$dfdc1655ccc5b9cb as serialize, $22de11b45b0eeb97$export$e209cbb66c5b18c as readAs};
//# sourceMappingURL=index.esm.js.map
