import { Observable } from 'iterable-observer';
export declare function parseDocument(response: Response): Promise<Document>;
export declare function makeFormData(data: Record<string, any>): FormData;
export declare function serializeNode(root: Node): {
    contentType: string;
    data: string;
} | {
    contentType: string;
    data: FormData;
};
export declare function serialize(data: any, contentType?: string): {
    data: FormData;
    contentType?: undefined;
} | {
    data: any;
    contentType: string;
};
declare enum FileMethod {
    text = "readAsText",
    dataURL = "readAsDataURL",
    binaryString = "readAsBinaryString",
    arrayBuffer = "readAsArrayBuffer"
}
export declare function readAs(file: Blob, method: keyof typeof FileMethod, encoding?: string): {
    progress: Observable<ProgressEvent<EventTarget>>;
    result: Promise<string | ArrayBuffer>;
};
export {};
